#ifndef EVENT_H_
#define EVENT_H_

void handle_key_event(XKeyEvent *e);
void handle_button_event(XEvent *e);
void handle_client_message(XClientMessageEvent *e);
void handle_configure_request(XConfigureRequestEvent *e);
void handle_enter_event(XCrossingEvent *e);
void handle_map_request(XMapRequestEvent *e);
void handle_property_change(XPropertyEvent *e);
void handle_unmap_event(XUnmapEvent *e);
void handle_destroy_event(XDestroyWindowEvent *e);

void move_window_x(const std::string&);
void move_window_y(const std::string&);
void move_window_upleft(const std::string&);
void move_window_upright(const std::string&);
void move_window_downleft(const std::string&);
void move_window_downright(const std::string&);
void delete_window(const std::string&);
void lower_window(const std::string&);
void info_window(const std::string&);
void maximise_window(const std::string&);
void maximise_window_vert(const std::string&);
void fix_window(const std::string&);
void exec_command(const std::string&);
void next_focus(const std::string&);
void switch_vdesk(const std::string&);
void next_vdesk(const std::string&);
void prev_vdesk(const std::string&);
void fix_next_vdesk(const std::string&);
void fix_prev_vdesk(const std::string&);
void up_focus(const std::string&);
void down_focus(const std::string&);
void right_focus(const std::string&);
void left_focus(const std::string&);
void upleft_focus(const std::string&);
void upright_focus(const std::string&);
void downleft_focus(const std::string&);
void downright_focus(const std::string&);
void wm_quit(const std::string&);
void wm_restart(const std::string&);
void mark_client_str(const std::string&);
void goto_mark_str(const std::string&);
void warp_pointer_x(const std::string&);
void warp_pointer_y(const std::string&);
void set_mode(const std::string&);
void raise_window(const std::string&);
void lower_window(const std::string&);
void iconize(const std::string&);
void mouse_move(const std::string&);
void mouse_resize(const std::string&);
void resize_window_x(const std::string&);
void resize_window_y(const std::string&);

#endif // ! EVENT_H_



