#include "evilwm.h"
#include "misc.h"
#include "ignore.h"

#include <fstream>
#include <algorithm>
#include <cctype>
#include <string>
#include <list>
#include <iterator>

Ignore::Ignore() {
    std::ifstream is(getConfigFile("ignore").c_str());
	strs_.push_back("s");
	std::copy(std::istream_iterator<std::string>(is),
			  std::istream_iterator<std::string>(),
			  std::back_inserter(strs_));

}

bool Ignore::isIgnore(const std::string& name) const {
    if (name.empty()) return true;

    if (strs_.end() != std::find(strs_.begin(), strs_.end(), name)) {
        return true;
    }

    std::string lower(name);
    lower[0] = tolower(lower[0]);
    if (strs_.end() != std::find(strs_.begin(), strs_.end(), lower)) {
        return true;
    }

    return false;
}
