#include "evilwm.h"
#include "mark.h"
#include "screen.h"

#include <stdio.h>
#include <ctype.h>

void mark_client(Client *c) {
	XEvent ev;
	char mark;
	int numchar;
	Client *oldc;

	if (XGrabKeyboard(dpy, root, False,
					  GrabModeAsync, GrabModeAsync, CurrentTime)
		!= GrabSuccess)
		return;

	/* wait for release KEY_MARK */
	XMaskEvent(dpy, KeyReleaseMask, &ev);

	/* get mark char */
	XMaskEvent(dpy, KeyPressMask, &ev);
	numchar = XLookupString(&ev.xkey, &mark, 1, NULL, NULL);
	if (numchar != 1)
		goto finish;
	
	if (!islower(mark))	/* in accord with vi */
		goto finish;
	
	/* find a client which has this 'mark' */
	oldc = find_marked_client(mark);
	if (oldc)
		oldc->mark = '\0';
	
	/* mark current client with this 'mark' */
	c->mark = mark;

finish:
	XUngrabKeyboard(dpy, CurrentTime);
	return;
}

void goto_mark() {
	XEvent ev;
	char mark;
	int numchar;
	Client *newc;

	if (XGrabKeyboard(dpy, root, False,
		GrabModeAsync, GrabModeAsync, CurrentTime) != GrabSuccess)
		return;

	/* wait for release KEY_GOTOMARK */
	XMaskEvent(dpy, KeyReleaseMask, &ev);

	/* get mark char */
	XMaskEvent(dpy, KeyPressMask, &ev);
	numchar = XLookupString(&ev.xkey, &mark, 1, NULL, NULL);
	if (numchar != 1)
		goto finish;

	if (!islower(mark))	/* in accord with vi */
		goto finish;
	
	/* find a client which has this 'mark' */
	newc = find_marked_client(mark);
	if (!newc)
		/* no client is with that mark */
		goto finish;

	switch_vdesk(RD_DESK(newc));

	pop(newc);

finish:
	XUngrabKeyboard(dpy, CurrentTime);
	return;
}

Client *find_marked_client(char mark) {
        Client *c;

        for (c = head_client; c; c = c->next)
                if (c->mark == mark) return c;
        return NULL;
}

